﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FieldLayoutsStyling
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public MainWindow()
        {
            InitializeComponent();

            Field fName = new Field
            {
                Name = "FirstName"
            };

            Field LName = new Field
            {
                Name = "LastName"
            };

            Field contacts = new Field
            {
                Name = "Contacts"
            };
            FieldLayout f1 = new FieldLayout();
            f1.IsDefault = true;

            f1.Key = "parent";
            f1.Fields.Add(fName);
            f1.Fields.Add(LName);
            f1.Fields.Add(contacts);

            FieldLayout f2 = new FieldLayout();
            f2.ParentFieldLayoutKey = "parent";
            f2.IsDefault = false;
            Field mobile = new Field
            {
                Name = "Mobile"
            };

            Field mail = new Field
            {
                Name = "Email"
            };

            f2.Fields.Add(mobile);
            f2.Fields.Add(mail);

            treeGrid.FieldLayouts.Add(f1);
            treeGrid.FieldLayouts.Add(f2);

        
        }




        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //Prepare data
            this.Persons = new ObservableCollection<Person>();

            //Add Employees
            for (int i = 1; i <= 10; i++)
            {

                this.Persons.Add
                    (

                       new Person()
                       {
                           FirstName  = "TestName " + i,
                           LastName = "LastName " + i,
                           Contacts = new ObservableCollection<Contact>()
                           {
                              new Contact()
                            {
                                Email = string.Concat("E", i.ToString(), "@email.com"),
                                Mobile = string.Concat("+44-000000000", i.ToString())
                            }
                           }
                       }
                    );
            }

           

            this.DataContext = this;
        }

        private ObservableCollection<Person> _persons;
        public ObservableCollection<Person> Persons
        {
            get
            {
                return this._persons;
            }

            set
            {
                this._persons = value;
                this.RaisePropertyChanged("Persons");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion

    }
    
   

    public class Person : INotifyPropertyChanged
    {
        private string _firstName;
        public string FirstName
        {
            get
            {
                return this._firstName;
            }

            set
            {
                this._firstName = value;
                this.RaisePropertyChanged("FirstName");
            }
        }

        private string _lastName;
        public string LastName
        {
            get
            {
                return this._lastName;
            }

            set
            {
                this._lastName = value;
                this.RaisePropertyChanged("LastName");
            }
        }

        private ObservableCollection<Contact> _contacts;
        public ObservableCollection<Contact> Contacts
        {
            get
            {
                return this._contacts;
            }

            set
            {
                this._contacts = value;
                this.RaisePropertyChanged("Contacts");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Contact : INotifyPropertyChanged
    {
        private string _mobile;
        public string Mobile
        {
            get
            {
                return this._mobile;
            }

            set
            {
                this._mobile = value;
                this.RaisePropertyChanged("Mobile");
            }
        }

        private string _email;
        public string Email
        {
            get
            {
                return this._email;
            }

            set
            {
                this._email = value;
                this.RaisePropertyChanged("Email");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
